#! /bin/sh
### BEGIN INIT INFO
# Provides:          comproxy
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Example initscript
# Description:       This file should be used to construct scripts to be
#                    placed in /etc/init.d.
### END INIT INFO

PATH=/sbin:/usr/sbin:/bin:/usr/bin
WORKDIR=/opt/comproxy
DESC="ComProxy services"
NAME=comproxy
DAEMON="$WORKDIR/jre/bin/java"
DAEMON_ARGS="-Xms16m -Xmx16m -XX:PermSize=16M -XX:MaxPermSize=16M -jar $WORKDIR/ComProxy.jar $WORKDIR"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
PID_SOCAT=$(pgrep -f "socat")
VIRTUAL_PORT1=`sed -n 's/port1=\(.*$\)/\1/p' $WORKDIR/socat.ini`
VIRTUAL_PORT2=`sed -n 's/port2=\(.*$\)/\1/p' $WORKDIR/socat.ini`
VIRTUAL_PORT3=`sed -n 's/port3=\(.*$\)/\1/p' $WORKDIR/socat.ini`
VIRTUAL_PORT4=`sed -n 's/port4=\(.*$\)/\1/p' $WORKDIR/socat.ini`
[ -z $VIRTUAL_PORT1 ] && VIRTUAL_PORT1=ttyS90
[ -z $VIRTUAL_PORT2 ] && VIRTUAL_PORT2=ttyS91
[ -z $VIRTUAL_PORT3 ] && VIRTUAL_PORT1=ttyS100
[ -z $VIRTUAL_PORT4 ] && VIRTUAL_PORT2=ttyS101

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

VERBOSE="yes"

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	# TODO: comment out when service logging will be implemented
	/usr/bin/socat -d -d pty,raw,mode=666,echo=0,LINK=/dev/$VIRTUAL_PORT1 pty,raw,echo=0,mode=666,LINK=/dev/$VIRTUAL_PORT2 > $WORKDIR/logs/socat.log 2>&1 &
	sleep 1
	/usr/bin/socat -d -d pty,raw,mode=666,echo=0,LINK=/dev/$VIRTUAL_PORT3 pty,raw,echo=0,mode=666,LINK=/dev/$VIRTUAL_PORT4 > $WORKDIR/logs/socat.log 2>&1 &
    sleep 1
	if [ ! -e /dev/$VIRTUAL_PORT1 -o ! -e /dev/$VIRTUAL_PORT2 ]; then
	    log_failure_msg "Socat failed to start...exiting"
	    log_end_msg 1
	    exit 1
	fi

	if [ ! -e /dev/$VIRTUAL_PORT3 -o ! -e /dev/$VIRTUAL_PORT4 ]; then
  	    log_failure_msg "Socat failed to start...exiting"
  	    log_end_msg 1
   	    exit 1
   	fi

	start-stop-daemon --quiet --pidfile $PIDFILE --start --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --quiet -b -d $WORKDIR --pidfile $PIDFILE --start --exec $DAEMON -- \
		$DAEMON_ARGS \
		|| return 2
# TODO: comment it when service logging will be implemented
#	cd $WORKDIR
#	PID_JAVA=$(pgrep -f "ComProxy.jar")
#	[ ! -z $PID_JAVA ] && return 1
#	$DAEMON $DAEMON_ARGS > $LOG_COMPROXY 2>&1 &
#	sleep 1
#	PID_JAVA=$(pgrep -f "ComProxy.jar")
#	[ -z $PID_JAVA ] && return 2 || return 0

	# Add code here, if necessary, that waits for the process to be ready
	# to handle requests from services started subsequently which depend
	# on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --retry=3 --pidfile $PIDFILE --name $NAME
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet --oknodo --retry=3 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
	#
	# If the daemon can reload its configuration without
	# restarting (for example, when it is sent a SIGHUP),
	# then implement that here.
	#
	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE--name $NAME
	return 0
}

case "$1" in
  start)
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC"


	do_start
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  stop)

	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC"
	for pid in `pgrep -f "socat"`; do
	    kill -s TERM $pid
	done

	sleep 2
	pgrep -f "socat" > /dev/null 2>&1

	if [ "$?" -eq 0 ]; then
    	#[ "$VERBOSE" != no ] && log_daemon_msg "Socat is still running. Sending KILL signal..."
        for pid in `pgrep -f "socat"`; do
            kill -s KILL $pid
        done
        rm -f /dev/$VIRTUAL_PORT1
        rm -f /dev/$VIRTUAL_PORT2
        rm -f /dev/$VIRTUAL_PORT3
        rm -f /dev/$VIRTUAL_PORT4
    #else
    	#[ "$VERBOSE" != no ] && log_daemon_msg "Socat has been stopped"
    fi

	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  status)
	status_of_proc "socat" "socat"
	status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
	;;
  #reload|force-reload)
	#
	# If do_reload() is not implemented then leave this commented out
	# and leave 'force-reload' as an alias for 'restart'.
	#
	#log_daemon_msg "Reloading $DESC" "$NAME"
	#do_reload
	#log_end_msg $?
	#;;
  restart|force-reload)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	log_daemon_msg "Restarting $DESC"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
		# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
	exit 3
	;;
esac

: